<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="学生名称" prop="studentName">
        <el-input
          v-model="queryParams.studentName"
          placeholder="请输入学生名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="班级名称" prop="className">
        <el-input
          v-model="queryParams.className"
          placeholder="请输入班级名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="所属专业" prop="majorId">
        <el-select
          v-model="queryParams.majorId"
          placeholder="请选择所属专业"
          clearable
          size="small"
        >
          <el-option
            v-for="major in selects"
            :key="major.majorId"
            :label="major.majorName"
            :value="major.majorId"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="年份" prop="year">
        <el-select v-model="queryParams.year" placeholder="请选择年份" clearable size="small">
          <el-option
            v-for="dict in dict.type.m_year"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="学院" prop="collegeId">
        <el-select v-model="queryParams.collegeId" placeholder="请选择学院" clearable size="small">
          <el-option
            v-for="dict in dict.type.m_college"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8" v-if=showColumn>
      <!-- <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['major:classResult:add']"
        >新增</el-button>
      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['major:classResult:edit']"
        >修改</el-button>
      </el-col> 
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleClass"
          v-hasPermi="['major:classResult:add']"
        >分班</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['major:classResult:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['major:classResult:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="classResultList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="学生名称" align="center" prop="studentName" />
      <el-table-column label="班级名称" align="center" prop="className" />
      <el-table-column label="所属专业" align="center" prop="majorName" />
      <el-table-column label="年份" align="center" prop="year">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.m_year" :value="scope.row.year"/>
        </template>
      </el-table-column>
      <el-table-column label="学院" align="center" prop="collegeId">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.m_college" :value="scope.row.collegeId"/>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" v-if=showColumn>
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['major:classResult:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['major:classResult:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改分流结果对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
      <el-form-item label="班级" prop="classId">
          <el-select v-model="form.classId" placeholder="请选择班级">
            <el-option v-for="classList in classes" :key="classList.classId" :label="classList.className" :value="parseInt(classList.classId)">
            </el-option>
          </el-select>
        </el-form-item>
        <!-- <el-form-item label="分流批次" prop="batchId">
          <el-select v-model="form.year" placeholder="请选择年份">
            <el-option
              v-for="dict in dict.type.m_year"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="学院" prop="collegeId">
          <el-select v-model="form.collegeId" placeholder="请选择学院">
            <el-option
              v-for="dict in dict.type.m_college"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item> -->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
        <!-- 分班 -->
    <el-dialog :title="title" :visible.sync="classOpen" width="500px" append-to-body>
      <el-form ref="formClass" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="分流批次" prop="batchId">
          <el-select v-model="form.year" placeholder="请选择年份">
            <el-option
              v-for="dict in dict.type.m_year"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="学院" prop="collegeId">
          <el-select v-model="form.collegeId" placeholder="请选择学院">
            <el-option
              v-for="dict in dict.type.m_college"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="clickClass">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listClassResult, getClassResult, delClassResult, addClassResult, updateClassResult, startClass } from "@/api/major/classResult";
import { listMajorInfo } from "@/api/major/majorInfo";
import { listDataFile } from "@/api/major/dataFile";
import { spareListClassInfo, listClassInfo } from "@/api/major/classInfo";

export default {
  name: "ClassResult",
  dicts: ['m_year', 'm_college'],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      showColumn: true,
      // 总条数
      total: 0,
      // 分班结果表格数据
      classResultList: [],
      dataFileList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      classOpen: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        studentId: null,
        studentName: null,
        classId: null,
        className: null,
        majorId: null,
        year: null,
        collegeId: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      selects:[],
      //班级列表
      classes:[],
    };
  },
  created() {
    this.queryParams.year = new Date().getFullYear();
    this.getList();
  },
  methods: {
    /** 查询分班结果列表 */
    getList() {
      this.loading = true;
      listClassResult(this.queryParams).then(response => {
        this.classResultList = response.rows;
        this.total = response.total;
        this.loading = false;
        // 归档校验
        const form = {};
        listDataFile(form).then(respone => {
          this.dataFileList = respone.rows;
          for (let i = 0; i < this.classResultList.length; i++) {
            for (let j = 0; j < this.dataFileList.length; j++) {
              if (this.classResultList[i].collegeId === this.dataFileList[j].collegeId && this.classResultList[i].year === this.dataFileList[j].year) {
                this.showColumn = false
                this.$modal.msgError("包含不可修改的数据，操作栏无法正常显示")
                return
              }else{
                this.showColumn = true
              }
            }
          }
        });
      });
      listMajorInfo().then((res) => {
        this.selects = res && res.rows;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.classOpen = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        studentId: null,
        classId: null,
        majorId: null,
        year: null,
        collegeId: null,
        classId: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加分班结果";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getClassResult(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改分班结果";
        this.queryParams.majorId = this.form.majorId
        this.queryParams.collegeId = this.form.collegeId
        listClassInfo(this.queryParams).then(response => {
        this.classes = response.rows;
      });
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateClassResult(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addClassResult(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /**分班按钮 */
    handleClass() {
      this.classOpen = true;
      this.title = "分班";
    },
    /**提交分班 */
    clickClass() {
      const _self = this
      this.$modal.confirm('是否确认进行分班').then(function() {
        _self.$refs["formClass"].validate(valid => {
          console.log("valid", valid)
          if (valid) {
            console.log(_self.form)
            return startClass(_self.form)
          }else{
            throw '校验不通过'
          }
        });
      }).then(()=>{
        setTimeout(()=>{
          this.getList();
          this.$modal.msgSuccess("分班成功");
        },1500)
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除分班结果编号为"' + ids + '"的数据项？').then(function() {
        return delClassResult(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('major/classResult/export', {
        ...this.queryParams
      }, `classResult_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
